#include "utiles.h"

// Imagenes que se van a usar para los menus - VARIABLES GLOBALES
extern Image*	menu_base;
extern Image*	menu_opcion1;
extern Image*	menu_opcion2;
extern Image*	menu_opcion3;
extern Image*	menu_opcion4;
extern Image*	menu_opcion5;
extern Image*	menu_opcion6;
extern Image*	menu_cargando;

extern Image 	*pregunta_base, *pregunta_num0, *pregunta_num1, *pregunta_num2, *pregunta_num3, *pregunta_num4, *pregunta_bloque, *pregunta_respuestas;

int texto(char fuente[], int size, int color, int rotacion, int x, int y, char texto[])
{
	int resultado = -1;

	SetupCallbacks();
	initGraphics();

	if (load_font(fuente))						// Actua solo si la fuente puede cargarse
	{
//		clearScreen(0);

		set_font_color(color);
		set_font_size(size);
		set_font_angle(rotacion);
		text_to_screen(texto, x, y);
		sceDisplayWaitVblankStart();
		flipScreen();
		
//		unload_font();						// Elimina la fuente de RAM
		resultado = 1;
	}
	return resultado;
}

int exit_callback(int arg1, int arg2, void *common)
{									// Exit callback 
          sceKernelExitGame();
          return 0;
}
 
int CallbackThread(SceSize args, void *argp)
{									// Callback thread
          int cbid;
 
          cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
          sceKernelRegisterExitCallback(cbid);
 
          sceKernelSleepThreadCB();
 
          return 0;
}
 
int SetupCallbacks(void)
{									// Sets up the callback thread and returns its thread id 
          int thid = 0;
 
          thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
          if(thid >= 0) {
                    sceKernelStartThread(thid, 0, 0);
          }
 
          return thid;
}

int mostrar_pregunta(char pregunta[], char respuesta1[],  char respuesta2[],  char respuesta3[],  char respuesta4[], int correcta, int tiempo, int color_jugador)
{

//	Image 	*pregunta_base, *pregunta_num0, *pregunta_num1, *pregunta_num2, *pregunta_num3, *pregunta_num4, *pregunta_bloque, *pregunta_respuestas;
	char	parte1[27], parte2[27];
	int	i=0, barra=0, pos_x=121, resultado=0, opcion=0, alternado=0, alternado2=0, alternado3=0, alternado4=0;
	SceCtrlData	dato_leido; 

/*	pregunta_base = loadImage("data/pregunta/base");				// Cargamos todas las imagenes que vamos a necesitar
	pregunta_num0 = loadImage("data/pregunta/00");
	pregunta_num1 = loadImage("data/pregunta/01");
	pregunta_num2 = loadImage("data/pregunta/02");
	pregunta_num3 = loadImage("data/pregunta/03");
	pregunta_num4 = loadImage("data/pregunta/04");
	pregunta_bloque = loadImage("data/pregunta/bloque");
	pregunta_respuestas = loadImage("data/pregunta/respuestas");
*/
//	load_font("type");
	set_font_angle(0);
	set_font_color(0xffffffff);
	
	blitAlphaImageToScreen( 0, 0, 480, 272, pregunta_base, 0, 0);	// Situamos la base
	
	// Pregunta
	set_font_size(18);

	// Tenemos que distinguir si la pregunta cabe en una linea o en dos (mayor de 27 caracteres o no)
	if (strlen(pregunta) > 25)
	{
		for (i=0; i<25; i++)					// Copiamos los primeros 25 caracteres
			parte1[i] = pregunta[i];
		parte1[i]='\0';						// y cerramos la cadena
		
		for (i=25; i<50 && ( i<(strlen(pregunta)) ); i++)
			parte2[i-25] = pregunta[i];			// Copiamos los siguientes 25 caracteres
		parte2[i-25]='\0';					// y cerramos la cadena. El resto de caracteres se pierde
	
	
		text_to_screen(parte1, 30, 49);				// Coloca cada linea de texto en su sitio
		text_to_screen(parte2, 30, 75);
		flipScreen();						// Actualizamos la pantalla	

		blitAlphaImageToScreen( 0, 0, 480, 272, pregunta_base, 0, 0);	// Situamos la base
		text_to_screen(parte1, 30, 49);				// Coloca cada linea de texto en su sitio
		text_to_screen(parte2, 30, 75);
		flipScreen();						// Actualizamos la pantalla	
	}
	else								// En caso de que quepa en una linea el texto
	{
		text_to_screen(pregunta, 30, 62);			// Coloca la pregunta en el centro de las dos lineas		
		flipScreen();						// Actualizamos la pantalla	

		blitAlphaImageToScreen( 0, 0, 480, 272, pregunta_base, 0, 0);	// Situamos la base
		text_to_screen(pregunta, 30, 62);			// Coloca la pregunta en el centro de las dos lineas		
		flipScreen();						// Actualizamos la pantalla	
	}
	// NOTA: se repite dos veces lo de colocar imagen+texto para luego al mostrar el contador descendente
	// que no vea la cache anterior
	

	// Esperamos un segundo y mostramos el siguiente valor del contador hasta llegar a cero
	sceKernelDelayThread(1000000);  				// Retardo de un segundo
	blitAlphaImageToScreen( 0, 0, 48, 32, pregunta_num4, 60, 196);		// Siguiente numero
	flipScreen();							// Actualizamos la pantalla	

	sceKernelDelayThread(1000000);  				// Retardo de un segundo
	blitAlphaImageToScreen( 0, 0, 48, 32, pregunta_num3, 60, 196);		// Siguiente numero
	flipScreen();							// Actualizamos la pantalla	

	sceKernelDelayThread(1000000);  				// Retardo de un segundo
	blitAlphaImageToScreen( 0, 0, 48, 32, pregunta_num2, 60, 196);		// Siguiente numero
	flipScreen();							// Actualizamos la pantalla	

	sceKernelDelayThread(1000000);  				// Retardo de un segundo
	blitAlphaImageToScreen( 0, 0, 48, 32, pregunta_num1, 60, 196);		// Siguiente numero
	flipScreen();							// Actualizamos la pantalla	

	sceKernelDelayThread(1000000);  				// Retardo de un segundo
	blitAlphaImageToScreen( 0, 0, 48, 32, pregunta_num0, 60, 196);		// Siguiente numero
	flipScreen();							// Actualizamos la pantalla	

	// Mostramos la parte de abajo con las respuestas y la barra de tiempo
	for (i=0; i<2; i++)
	{
		blitAlphaImageToScreen( 0, 0, 480, 168, pregunta_respuestas, 0, 104);	// Fondo para las respuestas
	
//		load_font("type");
		set_font_angle(0);
		set_font_color(0xffffffff);
		set_font_size(14);
		text_to_screen(respuesta1, 65, 135);
		text_to_screen(respuesta2, 65, 160);
		text_to_screen(respuesta3, 65, 185);
		text_to_screen(respuesta4, 65, 210);
		flipScreen();
	}

	blitAlphaImageToScreen( 0, 0, 10, 20, pregunta_bloque, pos_x, 245);	// Coloca la primera barra
        sceDisplayWaitVblankStart(); 
	flipScreen();							// Actualizamos la pantalla	

	// Entramos a contar tiempo y esperar pulsacion
	sceCtrlSetSamplingCycle(0); 					// Ciclo de pulsaciones a 0
	sceCtrlReadBufferPositive(&dato_leido, 1);
	while ( !(dato_leido.Buttons & (PSP_CTRL_TRIANGLE | PSP_CTRL_CROSS | PSP_CTRL_SQUARE | PSP_CTRL_CIRCLE)) && (barra<28) )
	{
		sceCtrlReadBufferPositive(&dato_leido, 1);
		sceKernelDelayThread((tiempo*1000000)/(28*16));  	// Retardo de una fraccion (1/(28*4)) del tiempo total disponible

		if(alternado4)		
		{
			if (alternado3)
			{					
				if(alternado2)
				{
					if (alternado)
					{
						blitAlphaImageToScreen( 0, 0, 10, 20, pregunta_bloque, pos_x, 245);		// Siguiente barra
					        sceDisplayWaitVblankStart(); 
						flipScreen();								// Actualizamos la pantalla	
			
						alternado=0;
					}
					else
					{
						blitAlphaImageToScreen( 0, 0, 10, 20, pregunta_bloque, pos_x, 245);
						sceDisplayWaitVblankStart(); 
						flipScreen();			

						pos_x = pos_x + 11;							// Pasa al siguiente lugar
						barra++;

						alternado=1;
					}
					alternado2=0;
				}
				else
					alternado2=1;	
				alternado3=0;
			}
			else
				alternado3=1;
			alternado4=0;
		}
		else
			alternado4=1;
	}
	
	// Liberamos de la ram las imagenes y la fuente
/*	freeImage(pregunta_respuestas);
	freeImage(pregunta_bloque);
	freeImage(pregunta_base);
	freeImage(pregunta_num0);
	freeImage(pregunta_num1);
	freeImage(pregunta_num2);
	freeImage(pregunta_num3);
	freeImage(pregunta_num4);
*/	
//	unload_font();

	// Si se ha respondido bien, se devuelve 1	
	if (dato_leido.Buttons & PSP_CTRL_TRIANGLE)			// Lee que boton se ha pulsado y devuelve el dato segun
		opcion = 1;						// cada caso
	if (dato_leido.Buttons & PSP_CTRL_SQUARE)
		opcion = 2;
	if (dato_leido.Buttons & PSP_CTRL_CIRCLE)
		opcion = 3;
	if (dato_leido.Buttons & PSP_CTRL_CROSS)
		opcion = 4;
		
	if (opcion == correcta)
		resultado = 1;

    	pspDebugScreenInit();	
	clearScreen(0);							// Limpia la pantalla
	pspDebugScreenClear();						// Limpia la pantalla

	return resultado;
}

void leernombre(char texto[], char *nombre[])				// Texto define la cabecera (pregunta) y nombre es el resultado que devolvemos como argumento
{
	SceCtrlData	dato_leido; 					// crea una variable para el Pad
	int 		ascii_num = 65, entrar = 1, i;			// contador de caracter ascii
	char 		caracter = 65;
	char		nombre_temp[50];
	
	for (i = 0; i < MAX_NOMBRE ; i ++)
		(nombre_temp)[i]='\0';					//limpia el contenido del registro

    	pspDebugScreenInit();						// Inicia la pantalla para escribir
	clearScreen(0);							// Limpia la pantalla
	pspDebugScreenClear();  					// Limpia la Pantalla


	pspDebugScreenSetTextColor(color2);				// Define el color de la fuente
	printf("%s", texto);						// Muestra la cabecera - como no se ha leido texto aun, no lo muestra

	pspDebugScreenSetTextColor(0x777777);				// Define el color de la fuente
	printf("%c", caracter);
	pspDebugScreenSetTextColor(color2);				// Define el color de la fuente
	
	while (!(dato_leido.Buttons & PSP_CTRL_CIRCLE) || entrar)	//sigue hasta que se pulse cuadrado
	{
		entrar = 0;
		
		sceCtrlReadBufferPositive(&dato_leido, 1);
		
		if (dato_leido.Buttons)
		{		
			if (dato_leido.Buttons & PSP_CTRL_UP && ascii_num < 127)
				ascii_num++;

			if (dato_leido.Buttons & PSP_CTRL_DOWN && ascii_num > 64)
				ascii_num--;
				
			caracter = ascii_num;
			
			if (dato_leido.Buttons & PSP_CTRL_CROSS && strlen((nombre_temp)) < MAX_NOMBRE-1)
			{	
				((nombre_temp))[strlen(nombre_temp)] = ascii_num;
				((nombre_temp))[strlen(nombre_temp)] = '\0';
				sceKernelDelayThread(delay);  		// Retardo de Tiempo
			}

			if (dato_leido.Buttons & PSP_CTRL_RIGHT && strlen((nombre_temp)) < MAX_NOMBRE-1)
			{	
				((nombre_temp))[strlen((nombre_temp))] = ' ';
				((nombre_temp))[strlen((nombre_temp))] = '\0';
			}
	
			if (dato_leido.Buttons & PSP_CTRL_LEFT && strlen((nombre_temp)) != 0)
				(nombre_temp)[strlen((nombre_temp)) -1] = '\0';

			pspDebugScreenClear();  			// Limpia la Pantalla
			
			printf("%s", texto);				// Muestra la cabecera
			printf("%s", (nombre_temp));			// El texto leido hasta el momento		

			pspDebugScreenSetTextColor(0x777777);		// Define el color de la fuente
			printf("%c", caracter);
			pspDebugScreenSetTextColor(color2);		// Define el color de la fuente			
		}		
		
		sceKernelDelayThread(delay);  				// Retardo de Tiempo
	}
	
//	printf("\nEl texto ha quedado: '%s'\n", (nombre_temp));
//	printf("\nSe ha pulsado el circulo, saliendo de la funcion al main!");

	sceKernelDelayThread(delay);  					// Retardo de Tiempo

	(nombre_temp)[strlen((nombre_temp))] = '\0';
	strcpy (nombre, nombre_temp);					// Copia el texto final al registro pasado como argumento
}

int menu( void )
{	
	int posicion = 1;
	SceCtrlData	dato_leido;
	Image	*img1, *img2;

	img1 = loadImage("data/menu1");					// Carga en RAM las dos imagenes posibles
	img2 = loadImage("data/menu2");
	sceDisplayWaitVblankStart(); 

	blitAlphaImageToScreen(0,0,480,272,img1,0,0);			// Muestra la primera
        flipScreen();


	sceCtrlSetSamplingCycle(0); 					// Ciclo de pulsaciones a 0

	sceCtrlReadBufferPositive(&dato_leido, 1);	
	while (!(dato_leido.Buttons & PSP_CTRL_CROSS))			// Si pulsas X termina
	{
		sceCtrlReadBufferPositive(&dato_leido, 1);

		if ( (dato_leido.Buttons & PSP_CTRL_UP) && posicion != 1)	// Si sube muestra la de arriba
		{ 
			posicion=1;						// Actualiza el valor de posicion
			blitAlphaImageToScreen(0,0,480,272,img1,0,0);		// y muestra la imagen correspondiente
        	        flipScreen();
		}

		if ( (dato_leido.Buttons & PSP_CTRL_DOWN) && posicion != 2)	// Si baja muestra la de abajo
		{ 
			posicion=2;
			blitAlphaImageToScreen(0,0,480,272,img2,0,0);
        	        flipScreen();
		}
	}

	// Libera de la ram las dos imagenes que ya no van a necesitarse
	freeImage(img1);
	freeImage(img2);

	// Temporal eliminar despues - Permite que funcione el juego ahora
//	pspDebugScreenInit();
//	pspDebugScreenSetXY(0,0);
	// Hasta aqui -

	return posicion;
}

void salir_creditos(void)
{
	Image	*c1, *c2, *c3, *c4;

	c1 = loadImage("data/creditos/c1");				// Carga en RAM las imagenes
	c2 = loadImage("data/creditos/c2");
	c3 = loadImage("data/creditos/c3");
	c4 = loadImage("data/creditos/c4");

	sceDisplayWaitVblankStart();
	blitAlphaImageToScreen(0,0,480,272,c1,0,0);			// Muestra la primera
        flipScreen();
	sceKernelDelayThread(3*1000000);				// Espera dos segundos

	sceDisplayWaitVblankStart();
	blitAlphaImageToScreen(0,0,480,272,c2,0,0);			// Muestra la segunda
        flipScreen();
	sceKernelDelayThread(3*1000000);				// Espera dos segundos
	sceDisplayWaitVblankStart();
	blitAlphaImageToScreen(0,0,480,272,c3,0,0);			// Muestra la tercera
        flipScreen();
	sceKernelDelayThread(3*1000000);				// Espera dos segundos
	sceDisplayWaitVblankStart();
	blitAlphaImageToScreen(0,0,480,272,c4,0,0);			// Muestra la cuarta y ultima
        flipScreen();

	freeImage(c1);							// Libera las imagenes de RAM
	freeImage(c2);
	freeImage(c3);
	freeImage(c4);
	
	sceKernelDelayThread(3*1000000);				// Espera dos segundos

	// Liberamos las imagenes de los menus
	freeImage(menu_base);
	freeImage(menu_opcion1);
	freeImage(menu_opcion2);
	freeImage(menu_opcion3);
	freeImage(menu_opcion4);
	freeImage(menu_opcion5);
	freeImage(menu_opcion6);
	freeImage(menu_cargando);

	freeImage(pregunta_respuestas);
	freeImage(pregunta_bloque);
	freeImage(pregunta_base);
	freeImage(pregunta_num0);
	freeImage(pregunta_num1);
	freeImage(pregunta_num2);
	freeImage(pregunta_num3);
	freeImage(pregunta_num4);


	// Liberamos la fuente TTF
	unload_font();

	sceKernelExitGame();						// Sale del juego
}

void mostrar_estadisticas(TPartida bloque_partida)
{	
    SceCtrlData	dato_leido; 						// Crea una variable para el Pad    
    int	i;
    
	clearScreen(0);							// Limpia la pantalla
	pspDebugScreenClear(); 						// Limpia la pantalla

	pspDebugScreenSetBackColor(0x3c3c3c);				// Actualiza el color del fondo
	pspDebugScreenSetTextColor(0xc3c3c3);				// Actualiza el color de la fuente		imagen3 = loadImage("data/logo1");


	pspDebugScreenClear(); 						// Limpia la pantalla
	
	printf("\n\n                          FIN DE LA PARTIDA!\n\n");	// Muestra el texto
	pspDebugScreenSetBackColor(0x2A1568);				// Actualiza el color del fondo	
	printf("\n");
	pspDebugScreenSetBackColor(0x05109F);				// Actualiza el color del fondo		

	for (i = 0; i < bloque_partida.num_jugadores; i ++)
	{
		pspDebugScreenSetBackColor(bloque_partida.jugador[i].color);	// Actualiza el color del fondo		
		printf("\n\n          %s, ha acumulado un total de %d puntos.\n\n           > Preguntas acertadas: %d\n           > Preguntas falladas: %d\n", bloque_partida.jugador[i].nombre, bloque_partida.jugador[i].puntuacion, bloque_partida.jugador[i].aciertos, bloque_partida.jugador[i].fallos );
	}	

	pspDebugScreenSetBackColor(0x2A1568);				// Actualiza el color del fondo	
	printf("\n");
	pspDebugScreenSetBackColor(0x3c3c3c);				// Actualiza el color del fondo		
	printf("\n\n                      PULSA X PARA CONTINUAR ...");
		
	sceKernelDelayThread(delay*5);
	sceCtrlReadBufferPositive(&dato_leido, 1);
	while (!(dato_leido.Buttons & PSP_CTRL_CROSS))	
		sceCtrlReadBufferPositive(&dato_leido, 1);
			
}

int contar_preguntas(char nombre_libreria[])
{
	int 		contabilizadas = 0;
	TCabecera	cabecera;
	FILE 		*archivo;
	char		texto_temp[MAX_FILENAME];			// Contendra la ruta + nombre de archivo
	
	texto_temp[0] = '\0';						// Inicializa el texto
	
	strcpy(texto_temp, "ms0:/psp/game/proypsp/lib/");		// Le inserta la ruta base
    	strcat(texto_temp, nombre_libreria);				// le anade el nombre de archivo concreto
	
	
	if ((archivo = fopen(texto_temp, "rb")))			// Carga el archivo
	{
		fread(&cabecera, sizeof(TCabecera), 1, archivo);	// Lee la cabecera del archivo
			
		contabilizadas = cabecera.preguntas_totales;		// Lee el total almacenado en la cabecera
	}
	else								// En caso de que no pueda cargarse el archivo se devuelve un -1
		contabilizadas = -1;
		
	fclose(archivo);
		
	return contabilizadas;	
}

int tirar_dado(TJugador jugador, int ronda, int posibilidades, int color_jugador)
{
	int	dado=1, marquesina = 0, i, direccion = 1, color = 0x990066;	// Direccion =1 -> derecha
    	SceCtrlData	dato_leido; 						// Crea una variable para el Pad
	Image	*img;
	char	texto_temporal[90];
		

	// Muestra la pantalla de presentacion de turno

	img = loadImage("data/turno");
	
	blitAlphaImageToScreen( 0, 0, 480, 272, img, 0, 0);
       	sceDisplayWaitVblankStart(); 
        flipScreen();

	blitAlphaImageToScreen( 0, 0, 480, 272, img, 0, 0);
       	sceDisplayWaitVblankStart(); 
        flipScreen();

	freeImage(img);

	sprintf(texto_temporal, "RONDA %d", ronda+1);

//	load_font("type");
	set_font_angle(0);
	set_font_color(0x6BAADB);
	set_font_size(35);
	text_to_screen(texto_temporal, 32, 160);

	set_font_color(0xffffffff);
	set_font_size(20);
	text_to_screen(jugador.nombre, 60, 260);

	flipScreen();
	
//	unload_font();

	sceCtrlReadBufferPositive(&dato_leido, 1);
	while (!(dato_leido.Buttons & PSP_CTRL_CROSS))			// Espera a que se pulse CRUZ para salir
		sceCtrlReadBufferPositive(&dato_leido, 1);		// Vuelve a leer pulsacion de tecla

	// De aqui en adelante es codigo de la marquesina en movimiento
	// que habra que actualizar para convertirlo a grafico

	sceKernelDelayThread(delay*5);
	sceCtrlReadBufferPositive(&dato_leido, 1);			// Lectura anticipada para entrar en el while

	pspDebugScreenInit();						// Inicia la pantalla para escribir
	pspDebugScreenSetBackColor(color_jugador);	
	pspDebugScreenClear(); 						// Limpia la pantalla
		
	while (!(dato_leido.Buttons & PSP_CTRL_CROSS))			// Espera a que se pulse CRUZ para salir del bucle
	{
		if (dado < posibilidades)
			dado ++;
		else
			dado = 1;
		
		printf("\n");						// Coloca un salto de linea siempre antes de empezar la marquesina
		
		if (direccion)						// Ir a la derecha
		{		
			if (marquesina < 56)
			{
				marquesina ++;
				color = color + 0x000402;
			}
			else
				direccion = 0;
		}
		else							// Ir a la izquierda
		{
			if (marquesina > 0)
			{
				marquesina --;
				color = color - 0x000402;
			}
			else
				direccion = 1;
		}
		
		pspDebugScreenSetTextColor(color);			// Actualiza el color de la fuente
				
		for (i = 0; i<marquesina; i++)				// Muestra la marquesina con el numero de espacios que toque
			printf(" ");
		printf("xxxxxxxxxx");
		
		sceCtrlReadBufferPositive(&dato_leido, 1);		// Vuelve a leer pulsacion de tecla
	}

	pspDebugScreenClear(); 						// Limpia la pantalla antes de salir

	return dado;							// Devuelve el valor del dado
}

void acierto(TPartida *bloque_partida, int num_jugador)
{
    SceCtrlData	dato_leido; 						// Crea una variable para el Pad
    

	// Actualiza la puntuacion del jugador
    
   	(*bloque_partida).jugador[num_jugador].puntuacion = (*bloque_partida).jugador[num_jugador].puntuacion + (100/(*bloque_partida).tiradas);
	(*bloque_partida).jugador[num_jugador].aciertos++;
    
    
    	pspDebugScreenClear(); 						// Limpia la pantalla

	pspDebugScreenSetBackColor(0x059915);				// Actualiza el color del fondo
	pspDebugScreenSetTextColor(0xDDDDDD);				// Actualiza el color de la fuente	

	pspDebugScreenClear(); 						// Limpia la pantalla

	printf("\n\n\n\n                         RESPUESTA CORRECTA !\n\n\n\n");		// Muestra el texto
	pspDebugScreenSetBackColor(0x2A6815);							// Actualiza el color del fondo	
	printf("\n\n\n");
	pspDebugScreenSetBackColor(0x059915);							// Actualiza el color del fondo		
	printf("\n\n\n          %s, has acumulado un total de %d puntos.\n\n\n\n           > Preguntas acertadas: %d\n\n           > Preguntas falladas: %d\n\n\n", (*bloque_partida).jugador[num_jugador].nombre, (*bloque_partida).jugador[num_jugador].puntuacion, (*bloque_partida).jugador[num_jugador].aciertos, (*bloque_partida).jugador[num_jugador].fallos );
	pspDebugScreenSetBackColor(0x2A6815);							// Actualiza el color del fondo	
	printf("\n\n\n");
	pspDebugScreenSetBackColor(0x059915);							// Actualiza el color del fondo		
	printf("\n\n\n\n\n                      PULSA X PARA CONTINUAR ...");
												// Muestra el texto
	
	sceKernelDelayThread(delay*5);
	sceCtrlReadBufferPositive(&dato_leido, 1);
	while (!(dato_leido.Buttons))	
		sceCtrlReadBufferPositive(&dato_leido, 1);
}

void fallo(TPartida *bloque_partida, int num_jugador)
{
    SceCtrlData	dato_leido; 						// Crea una variable para el Pad
    
    
	// Actualiza la puntuacion del jugador
    
   	(*bloque_partida).jugador[num_jugador].puntuacion = (*bloque_partida).jugador[num_jugador].puntuacion - (50/(*bloque_partida).tiradas);
	(*bloque_partida).jugador[num_jugador].fallos++;
    
    
	pspDebugScreenClear(); 						// Limpia la pantalla

	pspDebugScreenSetBackColor(0x05109F);				// Actualiza el color del fondo
	pspDebugScreenSetTextColor(0xDDDDDD);				// Actualiza el color de la fuente	

	pspDebugScreenClear(); 						// Limpia la pantalla
	
	printf("\n\n\n\n                        RESPUESTA INCORRECTA !\n\n\n\n");		// Muestra el texto
	pspDebugScreenSetBackColor(0x2A1568);							// Actualiza el color del fondo	
	printf("\n\n\n");
	pspDebugScreenSetBackColor(0x05109F);							// Actualiza el color del fondo		
	printf("\n\n\n          %s, has acumulado un total de %d puntos.\n\n\n\n           > Preguntas acertadas: %d\n\n           > Preguntas falladas: %d\n\n\n", (*bloque_partida).jugador[num_jugador].nombre, (*bloque_partida).jugador[num_jugador].puntuacion, (*bloque_partida).jugador[num_jugador].aciertos, (*bloque_partida).jugador[num_jugador].fallos );
	pspDebugScreenSetBackColor(0x2A1568);							// Actualiza el color del fondo	
	printf("\n\n\n");
	pspDebugScreenSetBackColor(0x05109F);							// Actualiza el color del fondo		
	printf("\n\n\n\n\n                      PULSA X PARA CONTINUAR ...");
		
	sceKernelDelayThread(delay*5);
	sceCtrlReadBufferPositive(&dato_leido, 1);
	while (!(dato_leido.Buttons))	
		sceCtrlReadBufferPositive(&dato_leido, 1);
}

void leer_pregunta(char libreria[], int numero_preg, TPregunta *pregunta)
{
	FILE 		*archivo;
	char		filename[MAX_FILENAME];
	TCabecera	cabecera;
	int			i=0;
	TPregunta	pregunta_temporal;
	
	filename[0]='\0';
	strcpy(filename, "ms0:/psp/game/proypsp/lib/");			// Crea la combinacion ruta+nombre de archivo
	strcat(filename, libreria);
	
	if( (archivo = fopen(filename, "rb")) )
	{
		fread(&cabecera, sizeof(TCabecera), 1, archivo);

		if (cabecera.preguntas_totales >= numero_preg)
		{
			for(i=0; i< numero_preg; i++)
				fread(&pregunta_temporal, sizeof(TPregunta), 1, archivo);

			(*pregunta) = pregunta_temporal;
		}
	}
	else
	{
		strcpy((*pregunta).pregunta, "ERROR CARGANDO PREGUNTA DE ARCHIVO");
		strcpy((*pregunta).respuesta1, "ERROR CARGANDO PREGUNTA DE ARCHIVO");
		strcpy((*pregunta).respuesta2, "ERROR CARGANDO PREGUNTA DE ARCHIVO");
		strcpy((*pregunta).respuesta3, "ERROR CARGANDO PREGUNTA DE ARCHIVO");
		strcpy((*pregunta).respuesta4, "ERROR CARGANDO PREGUNTA DE ARCHIVO");
	}
	fclose(archivo);
}

int pregunta(char pregunta[], int numero_respuestas, char respuesta1[], char respuesta2[], char respuesta3[], char respuesta4[], char respuesta5[], char respuesta6[])
{
	int 		posicion=1, i=0;
//	Image 		*base, *opcion1, *opcion2, *opcion3, *opcion4, *opcion5, *opcion6, *cargando;	
    	SceCtrlData	dato_leido;

/*	base    = loadImage("data/menu/base");				// Coloco la base del menu y la flecha de opcion 1
	opcion1 = loadImage("data/menu/opcion1");
	opcion2 = loadImage("data/menu/opcion2");			// Cargamos en ram las otras posibilidades
	opcion3 = loadImage("data/menu/opcion3");	
	opcion4 = loadImage("data/menu/opcion4");	
	opcion5 = loadImage("data/menu/opcion5");
	opcion6 = loadImage("data/menu/opcion6");	
	cargando = loadImage("data/cargando");				// Cargamos la imagen de "cargando" para despues
*/
//	load_font("type");
	set_font_angle(0);

	// Aqui hacemos una chapucilla: para no tener que renderizar el texto cada vez que mostramos una opcion, cosa que
	// ralentizaria mucho el funcionamiento del menu (debido a que la libreria flib accede a la fuente para cada letra
	// que renderiza) dibujamos el fondo y las letras sobre ambas caras de la pantalla, de forma que al hacer flipScreen
	// solo recargamos la parte de la flecha de opcion. El restoa, al estar igualmente pintado sobre ambas caras no cambia
	// y no tenemos que renderizar de nuevo.
	
	for (i=0; i<2; i++)
	{
		blitAlphaImageToScreen( 0, 0, 480, 272, menu_base, 0, 0);	// Cargamos el fondo base
	
		// ------- GENERACION DE LA SOMBRA -------
		// Generamos las mismas letras pero desplazadas a izquierda y abajo
		// y en color gris oscuro. Disimula el aliasing y da mejor estetica.

		set_font_color(0x22222222);

		// Titulo del menu
		set_font_size(18);
		text_to_screen(pregunta, 25, 66);			// CAMBIADO DE 28 A 25
	
		// Opciones del menu
		set_font_size(14);
		text_to_screen(respuesta1, 76, 121);
	
		if (numero_respuestas > 1)
			text_to_screen(respuesta2, 76, 146);
		if (numero_respuestas > 2)
			text_to_screen(respuesta3, 76, 171);
		if (numero_respuestas > 3)
			text_to_screen(respuesta4, 76, 196);
		if (numero_respuestas > 4)
			text_to_screen(respuesta5, 76, 221);
		if (numero_respuestas > 5)
			text_to_screen(respuesta6, 76, 246);


		// ------- GENERACION DEL TEXTO NORMAL -------

		set_font_color(0xffffffff);

		// Titulo del menu
		set_font_size(18);
		text_to_screen(pregunta, 27, 65);			// CAMBIADO DE 30 A 27
	
		// Opciones del menu
		set_font_size(14);
		text_to_screen(respuesta1, 78, 120);
	
		if (numero_respuestas > 1)
			text_to_screen(respuesta2, 78, 145);
		if (numero_respuestas > 2)
			text_to_screen(respuesta3, 78, 170);
		if (numero_respuestas > 3)
			text_to_screen(respuesta4, 78, 195);
		if (numero_respuestas > 4)
			text_to_screen(respuesta5, 78, 220);
		if (numero_respuestas > 5)
			text_to_screen(respuesta6, 78, 245);

	
		blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion1, 0, 95);	// Cargamos la flecha de la opcion 1
		flipScreen();						// Actualizamos la pantalla	
	}

	sceCtrlSetSamplingCycle(0);
	sceCtrlReadBufferPositive(&dato_leido, 1);
	while (!(dato_leido.Buttons & PSP_CTRL_CROSS))			// Si pulsas X termina
	{
		sceCtrlReadBufferPositive(&dato_leido, 1);

		if ( (dato_leido.Buttons & PSP_CTRL_UP) && (posicion > 1) )			// Si pulsas arriba sube (si no esta arriba del todo)
		{ 
			posicion--;		

			if (posicion == 1)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion1, 0, 95);        
			if (posicion == 2)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion2, 0, 95);        
			if (posicion == 3)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion3, 0, 95);        
			if (posicion == 4)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion4, 0, 95);        
			if (posicion == 5)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion5, 0, 95);        
			if (posicion == 6)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion6, 0, 95);        

//        		sceDisplayWaitVblankStart(); 
        	        flipScreen();
			
			sceKernelDelayThread(250000);
		}

		if ( (dato_leido.Buttons & PSP_CTRL_DOWN) && (posicion < numero_respuestas) )	// SI pulsas abajo baja (si no estas abajo del todo)
		{
			posicion++;

			if (posicion == 1)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion1, 0, 95);        
			if (posicion == 2)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion2, 0, 95);        
			if (posicion == 3)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion3, 0, 95);        
			if (posicion == 4)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion4, 0, 95);        
			if (posicion == 5)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion5, 0, 95);        
			if (posicion == 6)
				blitAlphaImageToScreen( 0, 0, 76, 177, menu_opcion6, 0, 95);        

//        		sceDisplayWaitVblankStart(); 
        	        flipScreen();
			
			sceKernelDelayThread(250000);
		}
	}
	
/*	freeImage(base);					// Elimina las imagenes de la RAM
	freeImage(opcion1);
	freeImage(opcion2);
	freeImage(opcion3);
	freeImage(opcion4);
	freeImage(opcion5);
	freeImage(opcion6);
*/
//	unload_font();						// Elimina la fuente de RAM

	pspDebugScreenSetBackColor(0x000000);

	blitAlphaImageToScreen( 0, 0, 480, 272, menu_cargando, 0, 0);	// Mostramos la imagen de cargando
	flipScreen();

	return posicion;
}

int leer_savegame(TJugador destino[], char filename[])			// Devuelve el numero total de jugadores cargados si todo ok y 0 si ha habido algun problema
{									// UTILIDAD : Copia en jugadores_cargados, que es un array de elementos de tipo TJugador, los datos extraidos del archivo
	FILE			*archivo;
	TJugador		temporal;				// Almacena la informacion de cada jugador segun se va extrayendo del archivo
	int			resultado, i=0;
	TCabecera_savegame	cabecera;
	
	sceIoChdir("ms0:/psp/game/proypsp/");
	
	if ((archivo = fopen(filename, "rb")))				// Abre el archivo
	{		
		fread (&cabecera, sizeof(TCabecera_savegame), 1, archivo);	// Leemos la cabecera del archivo de savegame

		for (i=0; i<cabecera.perfiles_totales; i++)
		{
			fread (&temporal, sizeof(TJugador), 1, archivo);	// Lectura de un bloque de perfil guardado
			destino[i] = temporal;
		}		
		if (!ferror(archivo))					// Comprueba que no haya habido errores
		{
			resultado = cabecera.perfiles_totales;		// Devuelve el total de perfiles cargados
		}
		else
			resultado=0;
	}
	else								// Si no ha podido abrir el archivo devuelve cero
		resultado = 0;

	fclose(archivo);
	return resultado;						// Devuelve el resultado que sea
}

void leer_librerias(TLista *lista_librerias)				// Devuelve la lista de librerias en /lib si todo ok y 0 si ha habido algun problema
{									// UTILIDAD : Despues tienes el nombre de archivo que copias en TJugador.libreria[]
									// y que puede ser leido cuando se necesite
									// NOTA: las librerias son cualquier archivo que no empiece por "."
	int i=0, j=0;
    	SceCtrlData	dato_leido; 					// crea una variable para el Pad	
	SceIoDirent dir;	
    	int uid;
    
    	for ( i=0; i<6; i++)						// Inicializa la lista de librerias
		(*lista_librerias).archivo[i][0] = '\0';
    
	i=0;
		
	memset(&dir, 0, sizeof(SceIoDirent));
    
	uid = sceIoDopen("ms0:/psp/game/proypsp/lib/");			// Carga el directorio /lib dentro de /proypsp
			
	for ( j=0; sceIoDread(uid, &dir) > 0; j++)			// En caso de que queden aun archivos en el directorio sin leer
	{
		if (dir.d_name[0] != '.' &&  i < 6)			// En caso de que el archivo no empiece por "." y no se haya llenado la lista
		{
			strcpy((*lista_librerias).archivo[i], dir.d_name);		// copia el nombre del archivo en la siguiente posicion no usada
			i++;								// Pasa a la siguiente posicion
		}	
	}
	
	sceIoDclose(uid);

	if (i)								// Si se ha leido algun nombre de archivo
		(*lista_librerias).numero = i;				// Devuelve el numero de archivos cargado
	else								// Si no se ha leido nada
	{
		printf("\n\n\n ERROR : No hay ninguna libreria!!");
		printf("\n\nPulsa una tecla para CONTINUAR ... ");

		sceKernelDelayThread(delay*5);
		sceCtrlReadBufferPositive(&dato_leido, 1);
		while (!(dato_leido.Buttons))	
			sceCtrlReadBufferPositive(&dato_leido, 1);
			
		(*lista_librerias).numero = 0;
	}
}

int imagen(char filename[], int start_x, int start_y, int size_x, int size_y, int x, int y)
{
	int resultado=-1;
	Image* img;

//	pspDebugScreenInit(); 
//	SetupCallbacks();
	initGraphics();

	if ( (img = loadImage(filename)) )
	{
                sceDisplayWaitVblankStart(); 
		blitAlphaImageToScreen( start_x, start_y, size_x, size_y, img, x, y);
                flipScreen();
		freeImage(img);

		resultado = 1;
	}

	return resultado;
}

void intro (void)
{
	Image *imagen1, *imagen2, *imagen3;

	pspAudioInit();
	MP3_Init(1);
	initGraphics();

	MP3_Load("data/audio/intro");					// Cargamos audio y logo
	imagen1 = loadImage("data/intro1");
	imagen2 = loadImage("data/intro2");
	imagen3 = loadImage("data/logo1");

	blitAlphaImageToScreen( 0, 0, 480, 272, imagen1, 0, 0);        

	MP3_Play();							// Reproducimos el audio
	sceKernelDelayThread(1500000);					// Esperamos 1.5 segundos
	sceDisplayWaitVblankStart(); 					// Mostramos el logo inicial
	flipScreen();

	sceKernelDelayThread(3500000);					// Esperamos 3.5 segundos
	blitAlphaImageToScreen( 0, 0, 480, 272, imagen2, 0, 0);        
	sceDisplayWaitVblankStart(); 					// Mostramos el logo inicial
	flipScreen();

	sceKernelDelayThread(3500000);					// Esperamos 3.5 segundos
	blitAlphaImageToScreen( 0, 0, 480, 272, imagen3, 0, 0);        
	sceDisplayWaitVblankStart(); 					// Mostramos el logo inicial
	flipScreen();

	sceKernelDelayThread(4300000);					// Esperamos 4.3 segundos
	MP3_Stop();							// Paramos el audio
	MP3_FreeTune();							// Liberamos el audio de RAM
	freeImage(imagen1);						// Liberamos la imagen de RAM
	freeImage(imagen2);
	freeImage(imagen3);
}

int guardar_perfil (TJugador perfil, char filename[])			// Guarda el perfil pasado en el archivo de savegame pasado.
{									// SUPONE QUE HAY ESPACIO LIBRE (MENOS DE SEIS PERFILES ALMACENADOS YA)
	int 	i=0;							// Devuelve el numero de perfiles almacenados al final
	FILE	*archivo;
	TCabecera_savegame cabecera;
	TJugador	perfiles[6];

	if ( (archivo = fopen(filename, "rb")) )			// Abre el archivo de savegame para leer la cabecera
	{
		fread (&cabecera, sizeof(TCabecera_savegame), 1, archivo );

		if ( !ferror(archivo) )					// Ha podido leer la cabecera correctamente y hay menos de seis perfiles
		{
			for (i=0; i<cabecera.perfiles_totales; i++)			// Lee todos los perfiles guardados
				fread (&perfiles[i], sizeof(TJugador), 1, archivo );

			fclose(archivo);						// Cerramos el archivo pues ya hemos terminado de leerlo

			// Copia el perfil a guardar al final del registro
			strcpy(perfiles[i].nombre, perfil.nombre);
			perfiles[i].puntuacion = perfil.puntuacion;
			perfiles[i].aciertos = perfil.aciertos;
			perfiles[i].fallos = perfil.fallos;
			perfiles[i].color = perfil.color;
			perfiles[i].victorias = perfil.victorias;

			// Incrementamos el total de perfiles guardados
			cabecera.perfiles_totales++;

			// Escribimos el archivo completo de nuevo
			archivo = fopen(filename, "wb");				// Abrimos para escribir

			fwrite(&cabecera, sizeof(TCabecera_savegame), 1, archivo);	// Escribimos la cabecera actualizada

			for (i=0; i<cabecera.perfiles_totales; i++)			// Escribimos los perfiles
				fwrite (&perfiles[i], sizeof(TJugador), 1, archivo );

			fclose(archivo);						// Cerramos el archivo
		}
	}

	return cabecera.perfiles_totales;
}

int borrar_perfil(char filename[], int num_perfil)			// Borra el perfil cuyo indice es num_perfil dentro del archivo 'filename'
{									// Empieza a contar por el 1 y llega hasta 6 como maximo
	FILE 		*archivo;
	int		i, entrar = 1;
	TCabecera_savegame cabecera;
	TJugador	perfiles[6];

	if ( (archivo = fopen(filename, "rb")) )			// Abre el archivo de savegame para leer la cabecera
	{
		fread (&cabecera, sizeof(TCabecera_savegame), 1, archivo );

		if ( !ferror(archivo) )					// Ha podido leer la cabecera correctamente y hay menos de seis perfiles
		{
			for (i=0; i<cabecera.perfiles_totales; i++)			// Lee todos los perfiles guardados
			{
				fread (&perfiles[i], sizeof(TJugador), 1, archivo );	
				if ( (i == (num_perfil-1))  && entrar )			// Si es el que se quiere borrar se retrasa el indice
				{
					i --;						// para compensar el incremento del for y asi pisar el
					entrar =0;					// registro que se desea borrar
					cabecera.perfiles_totales--;			// Decrementa el numero total de perfiles en caso de
				}							// que la ficha a borrar exista
			}
			fclose(archivo);						// Cerramos el archivo pues ya hemos terminado de leerlo

			// Escribimos el archivo completo con la informacion modificada
			archivo = fopen(filename, "wb");				// Abrimos para escribir

			fwrite(&cabecera, sizeof(TCabecera_savegame), 1, archivo);	// Escribimos la cabecera actualizada

			for (i=0; i<cabecera.perfiles_totales; i++)			// Escribimos los perfiles
				fwrite (&perfiles[i], sizeof(TJugador), 1, archivo );

			fclose(archivo);						// Cerramos el archivo
		}
	}
	return cabecera.perfiles_totales;
}

int contar_perfiles(char filename[])					// Devuelve el numero de perfiles contenido en un archivo de savegame
{
	TCabecera_savegame cabecera;
	int	resultado =0;
	FILE 	*archivo;
	
	if ( (archivo = fopen(filename, "rb")) )			// Abre el archivo de savegame para leer la cabecera
	{
		fread (&cabecera, sizeof(TCabecera_savegame), 1, archivo );
		
		if (!ferror(archivo))					// Si no ha habido problemas de archivo devuelve el total
			resultado = cabecera.perfiles_totales;

		fclose(archivo);
	}
	return resultado;
}

void actualizar_savegame(TPartida bloque_partida, char filename[])
{
	FILE 		*archivo;
	TJugador	jugadores[6];
	TCabecera_savegame cabecera;
	int		i=0, j=0, k=0;

	if ( (archivo=fopen(filename, "rb")) )					// Abre el archivo para leer
	{
		fread(&cabecera, sizeof(TCabecera_savegame), 1, archivo);	// Lee la cabecera

		for (i=0; i<cabecera.perfiles_totales; i ++)			// Extrae todos los perfiles que haya guardados
			fread(&jugadores[i], sizeof(TJugador), 1, archivo);

		fclose(archivo);						// Cerramos el archivo

		for (i=0; i<cabecera.perfiles_totales; i++)			// Busca en todos los perfiles guardados
			for (j=0; j<bloque_partida.num_jugadores; j++)		// Cada uno de los jugadores existentes
				if ( strcmp(bloque_partida.jugador[j].nombre, jugadores[i].nombre) == 0)	// Si concuerda el nombre copia los datos
				{
					jugadores[i].puntuacion += bloque_partida.jugador[j].puntuacion;
					jugadores[i].aciertos += bloque_partida.jugador[j].aciertos;
					jugadores[i].fallos += bloque_partida.jugador[j].fallos;
					// falta incrementar victoria si es necesario (comprobar si tiene la mayor puntuacion de todos antes de entrar en el 'if' inicial)
					for (k=0; k < MAX_PREGUNTAS; k++ )
						jugadores[i].respondidas[k] = bloque_partida.jugador[j].respondidas[k];

				}
		// Ya tenemos en jugadores[] la lista actualizada para meter al archivo
		if ( (archivo=fopen(filename, "wb")) )
		{
			fwrite(&cabecera, sizeof(TCabecera_savegame), 1, archivo);	// Escribe la cabecera

			for (i=0; i<cabecera.perfiles_totales; i ++)		// Guarda todos los perfiles actualizados
				fwrite(&jugadores[i], sizeof(TJugador), 1, archivo);

			fclose(archivo);
		}
	}
}


















