#ifndef UTILES_H
#define UTILES_H

#include "tipos.h"
#include "flib.h"
#include <pspaudiolib.h>


// Listado de prototipos de las funciones

extern 	int 	SetupCallbacks		(void);
extern 	int 	mostrar_pregunta	(char pregunta[], char respuesta1[],  char respuesta2[],  char respuesta3[],  char respuesta4[], int correcta, int tiempo, int color_jugador);
extern 	void 	leernombre		(char texto[], char *nombre[]);
extern 	int 	menu			(void);
extern 	void 	iniciar_juego		(TPartida bloque_partida);
extern 	void 	salir_creditos		(void);
extern 	void 	listar_archivos		(char *file[]);
extern 	void	mostrar_estadisticas 	(TPartida bloque_partida);
extern 	int 	contar_preguntas	(char nombre_libreria[]);
extern 	int 	tirar_dado		(TJugador jugador, int ronda, int posibilidades, int color_jugador);
extern 	void 	acierto			(TPartida *bloque_partida, int num_jugador);
extern 	void 	fallo			(TPartida *bloque_partida, int num_jugador);
extern 	void 	leer_pregunta		(char libreria[], int numero_preg, TPregunta *pregunta);
extern 	int 	pregunta		(char pregunta[], int numero_respuestas, char respuesta1[], char respuesta2[], char respuesta3[], char respuesta4[], char respuesta5[], char respuesta6[]);
extern 	int 	leer_savegame		(TJugador destino[], char filename[]);			// Devuelve el numero total de jugadores cargados si todo ok y 0 si ha habido algun problema
extern 	void 	leer_librerias		(TLista *lista_librerias);				// Devuelve la lista de librerias en /lib si todo ok y 0 si ha habido algun problema
extern 	int 	imagen			(char filename[], int start_x, int start_y, int size_x, int size_y, int x, int y);// Muestra una imagen dada en el sitio dado y el tamano dado - sirve para mostrar y mapear
extern 	void	intro			(void);
extern 	int 	texto			(char fuente[], int size, int color, int rotacion, int x, int y, char texto[]);
extern 	int 	contar_perfiles		(char filename[]); 					// Cuenta los perfiles que hay en el archivo de savegame pasado como argumento
extern	int 	guardar_perfil 		(TJugador perfil, char filename[]);			// Guarda el perfil pasado en el archivo de savegame pasado como argumento
extern	int 	borrar_perfil		(char filename[], int num_perfil);			// Borra el perfil cuyo indice es num_perfil dentro del archivo 'filename'
extern	void	actualizar_savegame	(TPartida bloque_partida, char filename[]);		// Actualiza los perfiles existentes en el savegame (los nombres que coincidan)



#endif
