#include <pspaudio.h>
#include <pspaudiolib.h>
#include "mp3player.h"
#include "graphics.h"
#include "flib.h"							// Manejo de fuentes TTF
#include "utiles.h"
#include "tipos.h"
//#include <smpeg.h>

PSP_MODULE_INFO("Freevial for PSP", 0, 1, 1);  				// Definimos el nombre del modulo
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER);  				// Definimos el MODO de la aplicacion en este caso es MODO USER

// Imagenes que se van a usar para los menus - VARIABLES GLOBALES
Image*	menu_base;
Image*	menu_opcion1;
Image*	menu_opcion2;
Image*	menu_opcion3;
Image*	menu_opcion4;
Image*	menu_opcion5;
Image*	menu_opcion6;
Image*	menu_cargando;

Image 	*pregunta_base, *pregunta_num0, *pregunta_num1, *pregunta_num2, *pregunta_num3, *pregunta_num4, *pregunta_bloque, *pregunta_respuestas;


void iniciar_juego(TPartida bloque_partida)
{
	int		tirada_actual, dado_actual, posibilidades, jugador_actual, i, j, vuelta = 0, salir =0;
	TPregunta	pregunta_temporal;				// Contiene la pregunta actual
//	char		texto_temporal[256];
    

	// CAMBIAR ESTO - SACARLO DE AQUI - HACER QUE SOLO INICIALICE EL REGISTRO DE AQUELLOS JUGADORES
	// QUE NO SON CARGADOS DE SAVEGAME, SINO SOLO LOS RECIEN CREADOS - PARA ELLO LO VAMOS A PASAR AL MAIN
	// A DONDE SE CREAN LOS JUGADORES NUEVOS
	// Lo hace por cada jugador
	for (i=0; i<bloque_partida.num_jugadores; i++)
	{
		// Pone a cero todos los flags de "pregunta ya respondida"
		for (j=0; j < MAX_PREGUNTAS; j++)
		bloque_partida.jugador[i].respondidas[j]=0;		
	}
		
	// Inicializa las puntuaciones de los jugadores que haya
	for (i = 0; i < bloque_partida.num_jugadores; i ++)
	{
		bloque_partida.jugador[i].puntuacion = 0;
		bloque_partida.jugador[i].aciertos = 0;
		bloque_partida.jugador[i].fallos = 0;
	}	
	
	// Continua mostrando preguntas mientras haya tiradas
	for (tirada_actual=0; tirada_actual < bloque_partida.tiradas; tirada_actual++)	
	{
		// Continua la ronda por cada jugador que haya
		for (jugador_actual = 0; jugador_actual < bloque_partida.num_jugadores; jugador_actual++)
		{
			if ( !(posibilidades = contar_preguntas(bloque_partida.jugador[jugador_actual].libreria) ))	// Cuenta cuantas preguntas hay en la libreria de este jugador
				posibilidades = 1;			

			// He incluido ahora esta linea de arriba (posibilidades = 1) para que en caso de que falle no se caiga el juego y te coja la primera 


			
			// ------- CODIGO TEMPORAL, BORRAR DESPUES ----------
//			clearScreen(0);						
// 			pspDebugScreenClear();  				
			// ------- HASTA AQUI, BORRAR DESPUES ----------
			

			// Prepara el texto para mostrarlo en pantalla
//			sprintf(texto_temporal, "\n\n\n            - RONDA %d -", tirada_actual+1);
//			strcat(texto_temporal,    "\n\n            > ");
//			strcat(texto_temporal, bloque_partida.jugador[jugador_actual].nombre);
//			strcat(texto_temporal, " - TIRA LOS DADOS !\n\n");
			
			dado_actual = tirar_dado(bloque_partida.jugador[jugador_actual], tirada_actual, posibilidades, bloque_partida.jugador[jugador_actual].color);	// Tira los dados con las posibilidades totales
			
//			printf("\n1");
//			sceKernelDelayThread(2*1000000);


			// Si esa pregunta ya ha salido muestra la siguiente y si es la ultima pasa a la anterior
			if (bloque_partida.jugador[jugador_actual].respondidas[dado_actual-1])
			{
//   				printf("\n\n La pregunta %d YA HA SALIDO ...", dado_actual);

				// Mientras haya salido, seguimos pasando hacia adelante de preguntq
				while ( bloque_partida.jugador[jugador_actual].respondidas[dado_actual-1] && !salir)
				{
					if (dado_actual < posibilidades)
					{
						// si no hemos llegado al final seguimos avanzando a ver si encontramos
						dado_actual++;
//						printf("\nAvanzamos buscando ... #%d", dado_actual);
					}
					else
					{	// Vamos a la primera para empezar otra vez a buscar disponibles
						if (vuelta == 0) // Si aun no hemos dado la vuelta completa va al principio
						{
							dado_actual = 1;
							vuelta = 1;
//							printf("\nVolvemos al principio ... #%d", dado_actual);
						}
						else	// En tal caso sale y reinicia el conteo de preguntas 
						{
							salir = 1;
						}
					}
				}
				// Nos quedamos en esa pero la marcamos tambien, pues la acabamos de mostrar
				bloque_partida.jugador[jugador_actual].respondidas[dado_actual-1] = 1;				
			}
			else	// Si la pregunta no ha salido la marca
			{
//				printf("\n\n La pregunta %d no ha salido aun, la marcamos ...", dado_actual);
				bloque_partida.jugador[jugador_actual].respondidas[dado_actual-1] = 1;				
			}
			// Si ya se hubiera agotado la libreria, vuelve a empezar de nuevas
			if (salir)
			{
				salir = 0;
				vuelta = 0;
				
//				printf("\nHemos agotado la libreria asi que la reiniciamos ...");
				// Limpiamos el cache de preguntas mostradas a ese jugador
				// Pone a cero todos los flags de "pregunta ya respondida"
				for (j=0; j < MAX_PREGUNTAS; j++)
					bloque_partida.jugador[jugador_actual].respondidas[j]=0;		

				// Volvemos a la primera pregunta
				dado_actual = 1;
				// y la marcamos como mostrada ya
				bloque_partida.jugador[jugador_actual].respondidas[dado_actual-1] = 1;				

			}

//			printf("\n2");
//			sceKernelDelayThread(2*1000000);

							
			// Carga la pregunta de la libreria segun el dado
			leer_pregunta(bloque_partida.jugador[jugador_actual].libreria, dado_actual, &pregunta_temporal);
				
//			printf("\n3");
//			sceKernelDelayThread(2*1000000);

	
			// La muestra y si es correcta va a acierto y si no a fallo
			if (mostrar_pregunta(pregunta_temporal.pregunta, pregunta_temporal.respuesta1,  pregunta_temporal.respuesta2,  pregunta_temporal.respuesta3,  pregunta_temporal.respuesta4, pregunta_temporal.correcta, bloque_partida.tiempo_pregunta, bloque_partida.jugador[jugador_actual].color))
				acierto	(&bloque_partida, jugador_actual);
			else
				fallo	(&bloque_partida, jugador_actual);
		}		
	}

	// Al terminar todas las rondas muestras las estadisticas del juego
	mostrar_estadisticas(bloque_partida);

	// Guarda las puntuaciones al archivo de savegame
	actualizar_savegame(bloque_partida, "savegame.tpsp");

}

int main(int argc, char* argv[])
{
//    SceCtrlData	dato_leido; 					// crea una variable para el Pad
    	int 		opcion = 1, guardados, temporal, i, j, k, l;	// Contiene la opcion del menu
    	TPartida	bloque_partida;					// Contiene todos los datos de la partida actual y de jugadores
    									// es ahi donde tiene que estar TODA la informacion de esa partida
	char texto_temporal[100];					// Registro temporal
	int color, n;							// Color elegido por cada jugador    													    													
    	TJugador	jugadores_cargados[6];    			// Contiene los perfiles cargados del archivo savegame.tpsp
	TLista		lista_librerias;				// Contiene la lista de nombres de librerias en /lib
    
 //   	pspDebugScreenInit();						// Inicia la pantalla para escribir
    	SetupCallbacks();
    	pspDebugScreenSetTextColor(0xffffff);				// Define el color de la fuente
    	sceCtrlSetSamplingCycle(1); 					// Ciclo de pulsaciones -> 0

	// Cargamos las imagenes y quedan listas para todo el juego - USAMOS VARIABLES GLOBALES
	menu_base    = loadImage("data/menu/base");
	menu_opcion1 = loadImage("data/menu/opcion1");
	menu_opcion2 = loadImage("data/menu/opcion2");
	menu_opcion3 = loadImage("data/menu/opcion3");	
	menu_opcion4 = loadImage("data/menu/opcion4");	
	menu_opcion5 = loadImage("data/menu/opcion5");
	menu_opcion6 = loadImage("data/menu/opcion6");	
	menu_cargando = loadImage("data/cargando");

	pregunta_base = loadImage("data/pregunta/base");		// Cargamos todas las imagenes que vamos a necesitar
	pregunta_num0 = loadImage("data/pregunta/00");
	pregunta_num1 = loadImage("data/pregunta/01");
	pregunta_num2 = loadImage("data/pregunta/02");
	pregunta_num3 = loadImage("data/pregunta/03");
	pregunta_num4 = loadImage("data/pregunta/04");
	pregunta_bloque = loadImage("data/pregunta/bloque");
	pregunta_respuestas = loadImage("data/pregunta/respuestas");


	// Cargamos la fuente TTF para escribir durante el juego
	load_font("type");


	// ----- IMAGENES DE INTRO DEL JUEGO ------
	intro();    
	// ----------------------------------------

    	opcion = menu();

    	while (1)
	{
	    switch (opcion)
	    {
			case 1:						// ELEGIDA NUEVA PARTIDA DESDE CERO
				{
					// pedir numero de jugadores
					bloque_partida.num_jugadores = pregunta("Numero de jugadores", 6, "Uno", "Dos", "Tres", "Cuatro", "Cinco", "Seis");
										
					// preguntar: de archivo o nuevo perfil de jugador? hasta igualar el valor de bloque_partida.num_jugadores
					for (i=0; i<bloque_partida.num_jugadores; i++)
					{
						// Comprueba si hay perfiles guardados, si no los hay pasa directamente a crear uno nuevo
						if (contar_perfiles("savegame.tpsp"))
							temporal = pregunta("Agregar jugador", 2, "Crear nuevo perfil", "Cargar perfil", "", "", "", "");
						else
							temporal =1;

						if (temporal == 2)					// Elegido -> leer perfil desde archivo
						{
							
							for (j=0; j<6; j++)				//  Bucle para inicializar el registro jugadores_cargados a cero en el campo de los nombres
								jugadores_cargados[i].nombre[0] = '\0';
							
							if ( (j = leer_savegame(jugadores_cargados, "savegame.tpsp")) )		// Carga desde el archivo savegame.tpsp las fichas de tipo TJugador que haya sobre jugadores_cargados
							{
								// Pregunta que perfil guardado quieres usar
								k = pregunta("Perfiles guardados", j, jugadores_cargados[0].nombre, jugadores_cargados[1].nombre, jugadores_cargados[2].nombre, jugadores_cargados[3].nombre, jugadores_cargados[4].nombre, jugadores_cargados[5].nombre);

								bloque_partida.jugador[i] = jugadores_cargados[k-1]; // Copia todos los datos del jugador leido

								// Preguntar que libreria usar									
								leer_librerias(&lista_librerias);
//								texto_temporal[0]='\0';									
								strcpy(texto_temporal, bloque_partida.jugador[i].nombre);
								strcat(texto_temporal, " - Elige tu libreria!");
									
								l = pregunta(texto_temporal, 4, lista_librerias.archivo[0], lista_librerias.archivo[1], lista_librerias.archivo[2], lista_librerias.archivo[3], lista_librerias.archivo[4], lista_librerias.archivo[5] );
								strcpy (bloque_partida.jugador[i].libreria, lista_librerias.archivo[l-1]);
								// Copia el nombre del archivo a la libreria de ese jugador

/*
								// Mostramos un resumen durante 10 segundos
								pspDebugScreenInit();
								clearScreen(0);
								printf("\n\nResumen de datos del jugador cargado:\n\nNombre %s\nPuntuacion: %d\nColor: %d\nLibreria: %s",bloque_partida.jugador[i].nombre,bloque_partida.jugador[i].puntuacion,bloque_partida.jugador[i].color,bloque_partida.jugador[i].libreria);
								sceKernelDelayThread(10*1000000);
*/

								// SEGUIR POR AQUI: COMPROBAR QUE LOS DATOS BINARIOS SE LEEN BIEN HACIENDO UN PRINTF DE LOS REGISTROS DE JUGADORES								
								
/*								printf("\n\n");
								printf("\nNombre: '%s'", jugadores_cargados[0].nombre);
								printf("\nNombre: '%s'", jugadores_cargados[1].nombre);
								printf("\nNombre: '%s'", jugadores_cargados[2].nombre);
								printf("\n\n");
								
								sceKernelDelayThread(delay*20);		
								
*/								// COMPROBADO: los datos se han cargado correctamente en jugadores_cargados
								
								
								// Se ha cargado con exito la lista de jugadores en savegame.tpsp
								
								// Recordemos que en j esta el total de jugadores cargados
								
																
								// mostrar lista contenida en savegame.tpsp y elegir el perfil
//								temporal = pregunta("Jugadores Guardados", j-1, jugadores_cargados[0].nombre, jugadores_cargados[1].nombre, jugadores_cargados[2].nombre, jugadores_cargados[3].nombre, jugadores_cargados[4].nombre, jugadores_cargados[5].nombre );

								// AQUI HAY QUE COMPROBAR, PORQUE LAS OPCIONES A ELEGIR NO SE MUESTRAN BIEN.
								
								// copiar los parametros en su ficha correspondiente en el bloque TPartida bloque_partida								
//								bloque_partida.jugador[i] = jugadores_cargados[temporal-1];
								
								// Aqui se muestra un resumen de bloque_partida.jugador[i] para comprobar que todo ha ido ok y para que el jugador lo vea.
								
//								printf("\n\nResumen de datos de jugador cargados:\n\nNombre %s\nPuntuacion: %d\nColor: %d\nLibreria guardada: %s",bloque_partida.jugador[i].nombre,bloque_partida.jugador[i].puntuacion,bloque_partida.jugador[i].color,bloque_partida.jugador[i].libreria);
								
//								sceKernelDelayThread(delay*40);		
//s								sceCtrlReadBufferPositive(&dato_leido, 1);								
								
								// CONTINUAR AQUI - HAY QUE CREAR UN ARCHIVO LLAMADO SAVEGAME.TPSP QUE TENGA DATOS GUARDADOS (bloques de tipo TJugador consecutivos).
								
							}
							else
							{
								// No se ha podido cargar el archivo savegame.tpsp o no tiene jugadores almacenados
								// Muestra la opcion de crear personajes nuevos								
							}
														
						// preguntar libreria a usar
														
						}
						else				// Elegido -> crear nuevo perfil de jugador
						{												
							//for (k=0; k<bloque_partida.num_jugadores; k ++);					// Repite hasta completar el numero de jugadores total
							{
									// pedir nombre				
								texto_temporal[0]='\0';								
								sprintf(texto_temporal, "%s%d%s", "\n\n\n\n\n          JUGADOR ", i+1, " - Escribe tu nombre! (pulsa O para terminar)\n\n\n     ");								
								leernombre(texto_temporal, bloque_partida.jugador[i].nombre);	// Pide el nombre y lo guarda en la ficha correspondiente
								
									// pedir color									
								texto_temporal[0]='\0';
								strcat(texto_temporal, bloque_partida.jugador[i].nombre);
								strcat(texto_temporal, " - Elige tu color!");
								
								color = pregunta (texto_temporal, 6,"Rojo", "Verde", "Azul", "Marron", "Morado", "Negro");	
								if (color == 1)
									bloque_partida.jugador[i].color = 0x000088; // Rojo
								if (color == 2)
									bloque_partida.jugador[i].color = 0x003700; // Verde
								if (color == 3)
									bloque_partida.jugador[i].color = 0x5b0000; // Azul
								if (color == 4)
									bloque_partida.jugador[i].color = 0x2b3959; // Marron
								if (color == 5)
									bloque_partida.jugador[i].color = 0x840045; // Morado
								if (color == 6)
									bloque_partida.jugador[i].color = 0x000000; // Negro
								
									// preguntar libreria a usar									
								leer_librerias(&lista_librerias);
								texto_temporal[0]='\0';									
								strcat(texto_temporal, bloque_partida.jugador[i].nombre);
								strcat(texto_temporal, " - Elige tu libreria!");
								
								//vamos a comprobar si lee bien la lista de librerias existente
//								printf("\n\nLista leida:\n\n");
//								for (m=0; m<lista_librerias.numero; m++)
//									printf("\n > '%s'", lista_librerias.archivo[m]);															
	
								l = pregunta(texto_temporal, 4, lista_librerias.archivo[0], lista_librerias.archivo[1], lista_librerias.archivo[2], lista_librerias.archivo[3], lista_librerias.archivo[4], lista_librerias.archivo[5] );
								strcpy (bloque_partida.jugador[i].libreria, lista_librerias.archivo[l-1]);
								// Copia el nombre del archivo a la libreria de ese jugador
			
								// inicializar estadisticas del jugador
								bloque_partida.jugador[i].puntuacion = 0;
								bloque_partida.jugador[i].aciertos = 0;
								bloque_partida.jugador[i].fallos = 0;
								bloque_partida.jugador[i].victorias = 0;
								
								
/*								// Prueba para ver si todo se ha almacenado bien:
								printf("\n         DATOS QUE SE HAN RECOGIDO\n");
								for (k=0; k<=i; k++)
								{
									printf("\nNombre: '%s'", bloque_partida.jugador[k].nombre);
									printf("\nColor: '%d'", bloque_partida.jugador[k].color);
									printf("\nLibreria: '%s'", bloque_partida.jugador[k].libreria);
									printf("\nPuntuacion: '%d'\n", bloque_partida.jugador[k].puntuacion);
								}								
									printf("\n\nPulsa una tecla para CONTINUAR ...");
								sceKernelDelayThread(delay*5);
								sceCtrlReadBufferPositive(&dato_leido, 1);
								while (!(dato_leido.Buttons))	
									sceCtrlReadBufferPositive(&dato_leido, 1);								
*/								

								// Preguntamos si quiere almacenar el jugador en la lista de perfiles guardados

								if ( pregunta("Quieres guardar el perfil?", 2, "No", "Si", "", "", "", "") == 2 )
								{
									if (contar_perfiles("savegame.tpsp") < 6)	// Comprueba que no este lleno
									{
										guardar_perfil(bloque_partida.jugador[i], "savegame.tpsp");
										// Mensaje: guardado ok (si guardar_perfil devuelve ok)
									}
									else	// Mensaje: no caben mas perfiles
									{
										if ( pregunta("No caben mas perfiles", 2, "No guardar","Borrar uno","","","","") == 2 )
										{
											guardados = leer_savegame(jugadores_cargados, "savegame.tpsp");
										// No hace falta contar cuantos hay porque sabemos que esta a tope

											k = pregunta("Cual quieres borrar?", guardados, jugadores_cargados[0].nombre, jugadores_cargados[1].nombre, jugadores_cargados[2].nombre, jugadores_cargados[3].nombre, jugadores_cargados[4].nombre, jugadores_cargados[5].nombre);
											borrar_perfil("savegame.tpsp", k);
											guardar_perfil(bloque_partida.jugador[i], "savegame.tpsp");
										}
									}
								}
							}	
						}
					}

					// mostrar opciones de juego como tiempo, etc y estadisticas
					n = pregunta("Tiempo de pregunta:",4,"15 Segundos","20 Segundos","25 Segundos","30 Segundos","","");
					
					if (n == 1)
						bloque_partida.tiempo_pregunta = 15;
					if (n == 2)
						bloque_partida.tiempo_pregunta = 20;
					if (n == 3)
						bloque_partida.tiempo_pregunta = 25;
					if (n == 4)
						bloque_partida.tiempo_pregunta = 30;
					
					bloque_partida.tiradas = 5 * pregunta("Numero de tiradas:",4,"A 5 preguntas","A 10 preguntas","A 15 preguntas","A 20 preguntas","","");
					
					pregunta ("EL JUEGO VA A EMPEZAR!",1,"Ya!","","","","","");
					// Sustituir por un mensaje simplemente---> MENSAJE: LISTOS PARA EMPEZAR !
					
/*					printf("\n\nOpciones de juego seleccionadas:\n\n > tiempo de pregunta: %d\n > numero de tiradas: %d", bloque_partida.tiempo_pregunta,bloque_partida.tiradas);
									printf("\n\nPulsa una tecla para CONTINUAR ...");
								sceKernelDelayThread(delay*5);
								sceCtrlReadBufferPositive(&dato_leido, 1);
								while (!(dato_leido.Buttons))	
									sceCtrlReadBufferPositive(&dato_leido, 1);								
*/					
					
					// iniciar juego
					iniciar_juego(bloque_partida);
				}
				break;
				
			case 2:
				{
					salir_creditos();
				}
				break;
				
			default:
				break;
	    }
    	opcion = menu();
	}
	
    	return 0;
}
